//----------------------------------------------------------------------//
// v	CtH[												//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <math.h>
#include <stdlib.h>
#include <algorithm>

#include "UIniFile.h"
#include "sntpcl.h"
#include "frmdraw.h"
#include "usr_wic.h"
#include "Unit1.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TMClockForm *MClockForm;

//---------------------------------------------------------------------------
__fastcall TMClockForm::TMClockForm(TComponent* Owner) : TForm(Owner)
{
	hFrmRegion = hDrwRegion = NULL;
	TrayIcon1  = NULL;
}

//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormCreate(TObject *Sender)
{
	VersionNo = get_VersionNo();

	Started   = false;
	ErrFlag   = false;

	hTrayIcon = NULL;

	TimeFont	  = new TFont();
	InfFont 	  = new TFont();
	MoonImage	  = new Graphics::TBitmap();
	ShadowImage   = new Graphics::TBitmap();
	BgImage 	  = new Graphics::TBitmap();
	ScheduleList1 = new TStringList();
	ScheduleList2 = new TStringList();

	//̏
	Koyomi = new KoyomiUnit();
	if (!Koyomi->ErrMsg.IsEmpty()) Application->MessageBox(Koyomi->ErrMsg.c_str(), _T("x"), MB_YESNO|MB_ICONWARNING);

	CurHoliday = new HolidayTable();
	CalHoliday = new HolidayTable();

	//NIvV̏
	UnicodeString path_name = EmptyStr;
	ExePath = ExtractFilePath(Application->ExeName);

	int i = 1;
	while (!ParamStr(i).IsEmpty()) {
		UnicodeString prmbuf = ParamStr(i++).Trim().UpperCase();
		if (prmbuf.SubString(1, 1)=="-") {
			if (prmbuf.SubString(2, 1)=="I") {
				prmbuf.Delete(1, 2);
				if (!prmbuf.IsEmpty()) path_name = ExePath + prmbuf;
			}
		}
	}
	if (path_name.IsEmpty()) path_name = ChangeFileExt(Application->ExeName, ".INI");

	bool first = (!FileExists(path_name));
	IniFile = new UsrIniFile(path_name);

	if (first) {
		//INIt@CȂꍇftHglŏ
		UnicodeString sct = "General";
		IniFile->WriteInteger(sct, "Version",			VersionNo);
		IniFile->WriteBool(   sct, "HideApplication",	true);
		IniFile->WriteBool(   sct, "TrayIcon",			false);
		IniFile->WriteBool(   sct, "StayOnTop",			true);
		IniFile->WriteBool(   sct, "MouseHide",			false);
		IniFile->WriteBool(   sct, "HideClock",			false);
		IniFile->WriteInteger(sct, "WinLeft",			50);
		IniFile->WriteInteger(sct, "WinTop",			50);
		IniFile->WriteInteger(sct, "Hour12",		 	0);
		IniFile->WriteBool(   sct, "ShowSec",			false);
		IniFile->WriteString( sct, "Shape",				EmptyStr);
		IniFile->WriteString( sct, "ShapePrmX",			EmptyStr);
		IniFile->WriteString( sct, "ShapePrmY",			EmptyStr);
		IniFile->WriteString( sct, "MarginX",			EmptyStr);
		IniFile->WriteString( sct, "MarginY",			EmptyStr);
		IniFile->WriteString( sct, "FontName",			"lr SVbN");
		IniFile->WriteInteger(sct, "FontSize",			18);
		IniFile->WriteBool(   sct, "FontBold",	 		false);
		IniFile->WriteBool(   sct, "FontItalic",	 	false);
		IniFile->WriteBool(   sct, "FontShadow",	 	false);
		IniFile->WriteInteger(sct, "FsPosX",		 	1);
		IniFile->WriteInteger(sct, "FsPosY",		 	1);
		IniFile->WriteInteger(sct, "TimeAlign",			1);
		IniFile->WriteString( sct, "InfFormat",			"\\y/\\m/\\d \\w");
		IniFile->WriteString( sct, "InfFormat2",		EmptyStr);
		IniFile->WriteString( sct, "InfFontSize",		9);
		IniFile->WriteString( sct, "InfFontName",		"lr SVbN");
		IniFile->WriteBool(   sct, "InfFontBold",		false);
		IniFile->WriteBool(   sct, "InfFontItalic",		false);
		IniFile->WriteBool(   sct, "InfShadow",			false);
		IniFile->WriteInteger(sct, "InfFsPosX",			1);
		IniFile->WriteInteger(sct, "InfFsPosY",			1);
		IniFile->WriteInteger(sct, "InfAlign",			1);
		IniFile->WriteString( sct, "FgColor", 			"0x" + IntToHex(DEF_FgColor, 6));
		IniFile->WriteString( sct, "FsColor",	 		"0x" + IntToHex(DEF_FsColor, 6));
		IniFile->WriteString( sct, "BgColor", 			"0x" + IntToHex(DEF_BgColor, 6));
		IniFile->WriteString( sct, "InfFgColor",		"0x" + IntToHex(DEF_FgColor, 6));
		IniFile->WriteString( sct, "InfFsColor",		"0x" + IntToHex(DEF_FsColor, 6));
		IniFile->WriteString( sct, "MonColor",			"0x" + IntToHex(DEF_MonColor, 6));
		IniFile->WriteString( sct, "ShdColor",			"0x" + IntToHex(DEF_ShdColor, 6));
		IniFile->WriteInteger(sct, "ShowMoon",	 		1);
		IniFile->WriteBool(	  sct, "MoonShading", 		false);
		IniFile->WriteString( sct, "MoonImage",			EmptyStr);
		IniFile->WriteString( sct, "ShadowImage",		EmptyStr);
		IniFile->WriteString( sct, "BgImage",			EmptyStr);
		IniFile->WriteBool(   sct, "StretchImage",		true);
		IniFile->WriteString( sct, "FrmStyle",			"Normal");
		IniFile->WriteInteger(sct, "FrmWidth",	 		1);
		IniFile->WriteString( sct, "FrmColor1",			"0x" + IntToHex(DEF_FrmColor, 6));
		IniFile->WriteInteger(sct, "CalMoonTime",		21);
		IniFile->WriteString( sct, "Editor",			"notepad.exe");
		IniFile->WriteString("Hour", "Sound",			EmptyStr);
		IniFile->WriteString("Half", "Sound",			EmptyStr);
		IniFile->WriteString("Quart","Sound",			EmptyStr);
		IniFile->WriteString("TimeAdjust","Server",		EmptyStr);
		IniFile->WriteBool(	  sct, "ShowKoyomiTip",		true);
		IniFile->WriteBool(	  sct, "ShowChangeYear",	false);
		IniFile->UpdateFile();
	}

	//pj[ڍ쐬
	for (int i=0; i<38; i++) {
		TMenuItem *mp	  = new TMenuItem(PopupMenu2->Items);
		CalDispItem[i]	  = mp;
		mp->Caption 	  = EmptyStr;
		mp->OnDrawItem	  = CalItemDrawItem;
		mp->OnMeasureItem = CalItemMeasureItem;
		PopupMenu2->Items->Add(mp);
	}

	CalHint = new THintWindow(this);
	CalHint->Brush->Color = clInfoBk;
	Application->ShowHint = true;

	//INIt@Cؑփj[ڂ쐬
	for (i=0; i<10; i++) {
		TMenuItem *mp  = new TMenuItem(ChgIniItem);
		IniFilItem[i]  = mp;
		mp->OnClick    = IniFilItemClick;
		ChgIniItem->Add(mp);
	}

	//TEhAǎAbZ[WXgNX쐬
	SoundPrm	 = new EventParam("Sound");
	SoundPlaying = false;
	WallPaperPrm = new EventParam("WallPaper");
	MessagePrm	 = new EventParam("Message");

	//SNTPNCAg쐬
	SNTPC = new SntpClient();

	//̗L݂
	Has_SE_SYSTIME = false;
	HANDLE hToken;
	if (::OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken)) {
		TOKEN_PRIVILEGES tknPrvlgs;
		if (::LookupPrivilegeValue(NULL, SE_SYSTEMTIME_NAME, &(tknPrvlgs.Privileges[0].Luid))) {
			tknPrvlgs.PrivilegeCount = 1;
			tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
			::AdjustTokenPrivileges(hToken, FALSE, &tknPrvlgs, 0, NULL, NULL);
			Has_SE_SYSTIME = (GetLastError()==ERROR_SUCCESS);
	 	}
	    ::CloseHandle(hToken);
	}

	//ݒ̓ǂݍ
	RecyclePrc(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormShow(TObject *Sender)
{
	::ShowWindow(Application->Handle, HideApp? SW_HIDE : SW_SHOW);
}

//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormDestroy(TObject *Sender)
{
	if (SoundPlaying) ::mciSendString(_T("close EventSound"), NULL, 0, NULL);

	delete CalHint;

	delete SoundPrm;
	delete WallPaperPrm;
	delete MessagePrm;

	if (hDrwRegion) ::DeleteObject(hDrwRegion);
	delete MoonImage;
	delete ShadowImage;
	delete BgImage;
	delete TimeFont;
	delete InfFont;
	delete ScheduleList1;
	delete ScheduleList2;
	delete Koyomi;
	delete SNTPC;

	delete CurHoliday;
	delete CalHoliday;

	IniFile->UpdateFile();
	delete IniFile;

	//^XNgC̃ACRj
	if (ShowTrayIcon) UpdateTrayIcon(NIM_DELETE);
}

//---------------------------------------------------------------------------
//WindowsȈ
//---------------------------------------------------------------------------
void __fastcall TMClockForm::WmQueryEndSession(TMessage& msg) {
	Perform(WM_CLOSE, 0, 0);
	msg.Result = 1;
}

//---------------------------------------------------------------------------
//jc[`bvŕ\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::ApplicationEvents1Hint(TObject *Sender)
{
	if (!Application->Hint.IsEmpty()) {
		UnicodeString msg; msg.sprintf(_T(" %s "), Application->Hint.c_str());
		TRect rc = CalHint->CalcHintRect(200, msg, NULL);
		rc.Offset(Mouse->CursorPos.x + 8, Mouse->CursorPos.y + 4);
		CalHint->ActivateHint(rc, msg);
	}
	else
		CalHint->ReleaseHandle();
}

//---------------------------------------------------------------------------
// v̕`
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormPaint(TObject *Sender)
{
	if (HideClock) {
		if (Visible) Hide(); return;
	}

	drwinf Dinf;
	LoadDrawInf(&Dinf, IniFile, "General");
	Dinf.form	= this;
	Dinf.region = hDrwRegion;
	Dinf.img	= BgImage;

	int rr = MoonSize;
	HRGN hMoonRgn = NULL;
	HRGN hFormRgn = ::CreateRectRgn(0, 0, Width, Height);

	//̊O`ݒ
	int x0 = MarginX;
	int y0 = MarginY;

	if (ShowMoon>0) {
		switch (ShowMoon) {
		case 2:	//
			x0 = Width - rr - MarginX; break;
		case 3:	//
		case 5:	//
		case 6: //̂
			x0 = (Width - rr)/2; break;
		case 4:	//
			x0 = (Width - rr)/2;
			y0 = Height - rr - MarginY;
			break;
		case 7: case 8:	//vO` = O`
			x0 = y0 = 0; break;
		}
		//̃[W쐬
		hMoonRgn = ::CreateEllipticRgn(x0, y0, x0 + rr, y0 + rr);
		//ṽ[W猎蔲
		::CombineRgn(hFormRgn, hFormRgn, hMoonRgn, RGN_XOR);
	}

	//v̔wiƘg`
	HRGN hOrgRgn  = (HRGN)::SelectObject(Canvas->Handle, hFormRgn);
	DrawFormEx(&Dinf);

	//̌``
	if (ShowMoon>0 && !MoonImage->Empty && !ShadowImage->Empty) {
		double mp = MoonInfo.phase;
		//ȈՃVF[fBO
		if (MoonShading) {
			std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
			bmp->SetSize(rr, rr);
			bmp->PixelFormat = pf24bit;
			bmp->Canvas->Draw(0, 0, MoonImage);

			double r2 = rr/2.0;
			double cc = 1.0-fabs(cos(M_PI*2.0*mp));
			double ck = cc*0.75 + 0.15;
			double z;
			if (mp<0.5)
				z = (mp<0.25)? (0.25 - mp) : 0;
			else
				z = (mp>0.75)? (mp - 0.75) : 0;
			z *= 4;
			if (z>0.9) z -= (1.0-((1.0-z)/0.1));
			z += 2.25;

			for (int j=0; j<rr; j++) {
				double ry  = r2 - j - 1;
				double rx  = sqrt(std::max((r2*r2 - ry*ry), 1.0));
				double rx0 = r2 - rx;
				double rx1 = r2 + rx;
				double md  = rx*cc;
				double rxp;
				if		(mp<=0.25) rxp = rx1 - md;
				else if (mp<=0.50) rxp = rx0 + md;
				else if (mp<=0.75) rxp = rx1 - md;
				else 			   rxp = rx0 + md;
				double rw = rr/40.0 + md/8.0;
				double rk = 50*rr/(rw + 1.0);
				BYTE *pM = (BYTE*)bmp->ScanLine[j];
				BYTE *pS = (BYTE*)ShadowImage->ScanLine[j];
				for (int i=0; i<rr; i++,pM+=3,pS+=3) {
					double a, b;
					if (i>=rx0 && i<=rx1) {
						a = 1.0;
						do {
							if (mp<0.5) {
								double rpp = rxp + rw;
								if (i>=rpp) break;
								b = rpp - i;
							}
							else {
								double rpp = rxp - rw;
								if (i<=rpp) break;
								b = i - rpp;
							}
							b /= (r2 + rw*2);
							b = pow(b, z);
							a = pow(ck, rk * b);
						} while(0);
					}
					else
						a = 0.0;
					if (a<0.01) {
						pM[0] = pS[0];
						pM[1] = pS[1];
						pM[2] = pS[2];
					}
					else if (a<1.0) {
						pM[0] = (BYTE)(std::min((pM[0]*a) + pS[0]*(1.0 - a), 255.0));
						pM[1] = (BYTE)(std::min((pM[1]*a) + pS[1]*(1.0 - a), 255.0));
						pM[2] = (BYTE)(std::min((pM[2]*a) + pS[2]*(1.0 - a), 255.0));
					}
				}
			}
			::SelectObject(Canvas->Handle, hMoonRgn);
			Canvas->Draw(x0, y0, bmp.get());
		}
		//ʏ`
		else {
			int xc = x0 + rr/2;
			int y1 = y0 + rr;
			int x1 = x0 + rr;
			//Pʂ`
			HRGN hTmpRgn;
			HRGN hIllumRgn = ::CreateRectRgn(0, 0, 0, 0);
			::CombineRgn(hIllumRgn, hIllumRgn, hMoonRgn, RGN_OR);
			if (mp<0.5)
				hTmpRgn = ::CreateRectRgn(xc, y0, x1, y1);
			else
				hTmpRgn = ::CreateRectRgn(x0, y0, xc, y1);
			::CombineRgn(hIllumRgn, hIllumRgn, hTmpRgn, RGN_AND);
			::DeleteObject(hTmpRgn);
			int md = floor(rr/2.0*(1.0 - fabs(cos(M_PI*2.0*mp))));
			hTmpRgn = ::CreateEllipticRgn(x0 + md, y0, x1 - md, y1);
			if (mp<=0.25 || mp>=0.75)
				::CombineRgn(hIllumRgn, hIllumRgn, hTmpRgn, RGN_DIFF);
			else
				::CombineRgn(hIllumRgn, hIllumRgn, hTmpRgn, RGN_OR);
			::DeleteObject(hTmpRgn);
			::SelectObject(Canvas->Handle, hIllumRgn);
			Canvas->Draw(x0, y0, MoonImage);
			//eʂ`
			HRGN hShadowRgn = ::CreateRectRgn(0, 0, 0, 0);
			::CombineRgn(hShadowRgn, hMoonRgn, hIllumRgn, RGN_XOR);
			::SelectObject(Canvas->Handle, hShadowRgn);
			Canvas->Draw(x0, y0, ShadowImage);

			::SelectObject(Canvas->Handle, hFormRgn);
			::DeleteObject(hIllumRgn);
			::DeleteObject(hShadowRgn);
		}
	}

	//\
	if (ShowMoon!=6 && ShowMoon!=8) {
		//
		Canvas->Font->Assign(TimeFont);
		if (ShowMoon==5 || ShowMoon==7) ::CombineRgn(hFormRgn, hFormRgn, hMoonRgn, RGN_OR);
		::SelectObject(Canvas->Handle, hFormRgn);

		int topx = MarginX;
		y0 = MarginY;
		switch (ShowMoon) {
		case 1: topx+= (rr + rr/8); break;	//̉E
		case 3: y0 += (rr + rr/8);  break;	//̉
		case 5: y0 += (rr/4); 	    break;	//̑O
		}

		x0 = 0;
		UnicodeString tbuf = EmptyStr;
		int hh = CurHour;
		if (Hour12>0 && CurHour>12) hh -= 12;
		if (ShowSec==0)
			tbuf.sprintf(_T("%02u:%02u"), hh, CurMin);
		else
			tbuf.sprintf(_T("%02u:%02u:%02u"), hh, CurMin ,CurSec);
		int xwd = std::max(MaxInfWidth, MaxTimeWidth);

		if (MaxTimeWidth < MaxInfWidth) {
			switch (TimeAlign) {
			case 1: x0 = (xwd - MaxTimeWidth)/2;	break;
			case 2: x0 = xwd - MaxTimeWidth;		break;
			}
		}

		if (ShowMoon==7) y0 = (rr - Canvas->TextHeight(tbuf))/2;
		if (TmMetric.tmInternalLeading>0)
			y0 -= (TmMetric.tmInternalLeading - TmMetric.tmDescent/2);

		int x1;	//am/pm̕\ʒu
		if (Hour12>1) {
			switch (Hour12) {
			case 2: case 4: case 6: case 8:
				//ɕ\
				x1	= x0;
				x0 += AmPmWidth;
				break;
			default:
				//Eɕ\
				x1 = x0 + (MaxTimeWidth - AmPmWidth) + AmPmXofs;
			}
		}
		x0 += topx;
		x1 += topx;

		Canvas->Brush->Style = bsClear;
		//e
		if (FontShadow) {
			Canvas->Font->Color = ColFntShd;
			Canvas->TextOut(x0 + FsPosX, y0 + FsPosY, tbuf);
			Canvas->Font->Color = TimeFont->Color;
		}
		//
		if (SoundPlaying) Canvas->Font->Color = ColFntPly;
		Canvas->TextOut(x0, y0, tbuf);

		//am/pm \
		if (Hour12>1) {
			switch (Hour12) {
			case 2: case 3: case 6: case 7:
				tbuf = (CurHour<12) ? "am" : "pm"; break;
			case 4: case 5: case 8: case 9:
				tbuf = (CurHour<12) ? "AM" : "PM"; break;
			}
			if (Hour12<6) Canvas->Font->Size = std::max(TimeFont->Size/2, 8);
			if (FontShadow) {
				Canvas->Font->Color = ColFntShd;
				Canvas->TextOut(x1 + FsPosX, y0 + AmPmYofs + FsPosY, tbuf);
				Canvas->Font->Color = TimeFont->Color;
			}
			if (SoundPlaying) Canvas->Font->Color = ColFntPly;
			Canvas->TextOut(x1, y0+AmPmYofs, tbuf);
			Canvas->Font->Size = TimeFont->Size;
		}

		//ǉ\
		int inf_ofs = 0;
		if (!InfFormat.IsEmpty()) {
			UnicodeString abuf = InfFormat;
			ExpFormChar(abuf);
			Canvas->Font->Assign(InfFont);
			int x2 = 0;
			switch (InfAlign) {
			case 1:  x2 = (xwd - Canvas->TextWidth(abuf))/2; break;
			case 2:  x2 = (xwd - Canvas->TextWidth(abuf));   break;
			}
			x2 += topx;
			//e
			if (InfShadow) {
				Canvas->Font->Color = ColInfShd;
				Canvas->TextOut(x2 + InfFsPosX, y0 + TimeHeight + InfFsPosY, abuf);
				Canvas->Font->Color = InfFont->Color;
			}
			Canvas->TextOut(x2, y0 + TimeHeight, abuf);
			inf_ofs = Canvas->TextHeight(abuf) + 1;
		}
		//ǉ2\
		if (!InfFormat2.IsEmpty()) {
			UnicodeString abuf = InfFormat2;
			ExpFormChar(abuf);
			Canvas->Font->Assign(InfFont);
			int x2 = 0;
			switch (InfAlign) {
			case 1:  x2 = (xwd - Canvas->TextWidth(abuf))/2; break;
			case 2:  x2 = (xwd - Canvas->TextWidth(abuf));   break;
			}
			x2 += topx;
			y0 += inf_ofs;
			//e
			if (InfShadow) {
				Canvas->Font->Color = ColInfShd;
				Canvas->TextOut(x2 + InfFsPosX, y0 + TimeHeight + InfFsPosY, abuf);
				Canvas->Font->Color = InfFont->Color;
			}
			Canvas->TextOut(x2, y0+TimeHeight, abuf);
		}
	}

	::SelectObject(Canvas->Handle, hOrgRgn);
	::DeleteObject(hFormRgn);
	if (hMoonRgn) ::DeleteObject(hMoonRgn);

}

//---------------------------------------------------------------------------
// ݎXV
//---------------------------------------------------------------------------
void __fastcall TMClockForm::UpdateNow()
{
	CurTime = ((int)TestTime==0) ? Now() : TestTime;
	DecodeTime(CurTime, CurHour, CurMin, CurSec, CurMsc);
	DecodeDate(CurTime, CurYear, CurMon, CurDay);
	CurWek	 = CurTime.DayOfWeek();
	CurCount = CurHour*3600L + CurMin*60 + CurSec;
}

//---------------------------------------------------------------------------
// ݂̓ŌXV
//---------------------------------------------------------------------------
void __fastcall TMClockForm::UpdateMoonInfo()
{
	MoonInfo.cur_dt = CurTime;
	GetMoonInfo(&MoonInfo);
	if (TestMoonAage>=0) {
		MoonInfo.age   = TestMoonAage;
		MoonInfo.phase = TestMoonAage/29.53;
	}
}


//---------------------------------------------------------------------------
// ̓WJ
//	\y				2
//	\Y				4
//	\0m						01`12
//	\m						1`12
//	\M						Jan`Dec
//	\MM						January ` December
//	\0d						01`31
//	\d						1`31
//	\w				j	`y
//	\W				j	Sun`Sat
//	\WW				j	Sunday ` Saturday
//	\t					hh:mm
//	\a					0.0`29.5
//	\xyyyy/mm/dd	yyyy/mm/dd ܂ł̓
//	\H				j
//	\R				vN(ēǍ)̌oߎ    hh:mm:ss
//	\C				̃Cxg܂ł̎c莞      hh:mm:ss
//	\I				WindowsŇoߎ           hh:mm:ss
//	\S1,\S2			\胊Xg1,2
//	\K1				t    : 11 9
//	\K2				x Zj   : C 揟
//	\K3				ߋGEG  : ~
//	\BP				obec%	0`100	s̏ꍇ ---
//	\BT				obec	hh:mm	s̏ꍇ --:--:--
//---------------------------------------------------------------------------
void __fastcall TMClockForm::ExpFormChar(UnicodeString &s)
{
	UnicodeString cur_m = MonthStrE[CurMon - 1];
	UnicodeString cur_w = WeekStrE[CurWek - 1];
	UnicodeString swd, rwd, dwd;

	_TCHAR hol_name[31];
	CurHoliday->IsHoliday(CurYear, CurMon, CurDay, hol_name);
	UnicodeString k_str = Koyomi->GetInfoStr(CurYear, CurMon, CurDay);
	UnicodeString k1str = get_tkn(k_str, "\t"); k_str = get_tkn_r(k_str, "\t");
	UnicodeString k2str = get_tkn(k_str, "\t");
	UnicodeString k3str = get_tkn_r(k_str, "\t");

	for (int i=0; i<25; i++) {
		switch (i) {
		case  0: swd = "\\x";											break;
		case  1: swd = "\\Y";  rwd = FormatDateTime("yyyy", CurTime);	break;
		case  2: swd = "\\y";  rwd = FormatDateTime("yy",   CurTime);	break;
		case  3: swd = "\\MM"; rwd = cur_m; 							break;
		case  4: swd = "\\M";  rwd = cur_m.SubString(1, 3);				break;
		case  5: swd = "\\0m"; rwd = FormatDateTime("mm",	CurTime); 	break;
		case  6: swd = "\\m";  rwd = FormatDateTime("m",	CurTime); 	break;
		case  7: swd = "\\0d"; rwd = FormatDateTime("dd",	CurTime); 	break;
		case  8: swd = "\\d";  rwd = FormatDateTime("d",	CurTime); 	break;
		case  9: swd = "\\WW"; rwd = cur_w; 							break;
		case 10: swd = "\\W";  rwd = cur_w.SubString(1, 3);				break;
		case 11: swd = "\\w";  rwd = WeekStrJ[CurWek - 1];				break;
		case 12: swd = "\\t";  rwd = FormatDateTime("hh:nn", CurTime);	break;
		case 13: swd = "\\a";  rwd = FloatToStrF(MoonInfo.age, ffFixed, 4, 1); break;
		case 14: swd = "\\H";  rwd = hol_name;							break;
		case 15:
			swd = "\\R";
			rwd = FormatDateTime("hh:nn:ss",(TDateTime)((::GetTickCount()/1000L - StartCount)/86400.0));
			break;
		case 16:
			swd = "\\C";
			rwd = FormatDateTime("hh:nn:ss",(TDateTime)(NxtDwnCount/86400.0));
			break;
		case 17:
			swd = "\\I";
			rwd = FormatDateTime("hh:nn:ss",(TDateTime)(::GetTickCount()/1000L/86400.0));
			break;
		case 18:
			swd = "\\S1";
			rwd = ScheduleList1->Values[FormatDateTime("yyyy/mm/dd", CurTime)];
			break;
		case 19:
			swd = "\\S2";
			rwd = ScheduleList2->Values[FormatDateTime("yyyy/mm/dd", CurTime)];
			break;
		case 20: swd = "\\K1"; rwd = k1str;	break;
		case 21: swd = "\\K2"; rwd = k2str;	break;
		case 22: swd = "\\K3"; rwd = k3str;	break;
		case 23: swd = "\\BP"; rwd = get_BatteryPercentStr();	break;
		case 24: swd = "\\BT"; rwd = get_BatteryTimeStr();		break;
		}

		int p;
		while ((p=s.Pos(swd)) != 0) {
			if (i==0) {	//yyyy/mm/dd ܂ł̓
				try {
					rwd = IntToStr((int)StrToDate(s.SubString(p + 2, 10)) - (int)CurTime);
				}
				catch (EConvertError &e) {
					rwd = "[G[!]";
				}
				s.Delete(p, 12);
			}
			else
				s.Delete(p, swd.Length());
			s.Insert(rwd, p);
		}
	}
}

//---------------------------------------------------------------------------
// WJۂ̍ő啝\z
//---------------------------------------------------------------------------
int __fastcall TMClockForm::GetMaxFormWidth(TCanvas *cv, UnicodeString s)
{
	UnicodeString str24 = EmptyStr;	//"00"`"23"̊Ԃ̍ő啝
	UnicodeString str60 = EmptyStr;	//"00"`"59"̊Ԃ̍ő啝
	for (int i=0; i<60; i++) {
		UnicodeString t = UnicodeString().sprintf(_T("%02u"), i);
		if (i<24) {
			if (cv->TextWidth(t) > cv->TextWidth(str24)) str24 = t;
		}
		if (cv->TextWidth(t) > cv->TextWidth(str60)) str60 = t;
	}

	//\胊Xg̍ő啝
	UnicodeString SLstr1 = EmptyStr;
	for (int i=0; i<ScheduleList1->Count; i++) {
		UnicodeString tmpstr = ScheduleList1->Strings[i]; if (tmpstr.IsEmpty()) continue;
		tmpstr.Delete(1, 11);
		if (tmpstr.Length()>SLstr1.Length()) SLstr1 = tmpstr;
	}
	UnicodeString SLstr2 = EmptyStr;
	for (int i=0; i<ScheduleList2->Count; i++) {
		UnicodeString tmpstr = ScheduleList2->Strings[i]; if (tmpstr.IsEmpty()) continue;
		tmpstr.Delete(1, 11);
		if (tmpstr.Length()>SLstr2.Length()) SLstr2 = tmpstr;
	}

	UnicodeString swd, rwd;
	for (int i=0; i<25; i++) {
		switch (i) {
		case  0: swd = "\\x";  rwd = "999"; 					break;
		case  1: swd = "\\Y";  rwd = "2000";					break;
		case  2: swd = "\\y";  rwd = "00";						break;
		case  3: swd = "\\MM"; rwd = "September";				break;
		case  4: swd = "\\M";  rwd = "May"; 					break;
		case  5: swd = "\\0m"; rwd = "12";						break;
		case  6: swd = "\\m";  rwd = "12";						break;
		case  7: swd = "\\0d"; rwd = "29";						break;
		case  8: swd = "\\d";  rwd = "29";						break;
		case  9: swd = "\\WW"; rwd = "Wednesday";				break;
		case 10: swd = "\\W";  rwd = "Wed"; 					break;
		case 11: swd = "\\w";  rwd = "";						break;
		case 12: swd = "\\t";  rwd = str24+":"+str60;			break;
		case 13: swd = "\\a";  rwd = "29.5";					break;
		case 14: swd = "\\H";  rwd = "ΘJӂ̓";			break;
		case 15: swd = "\\R";  rwd = str24+":"+str60+":"+str60; break;
		case 16: swd = "\\C";  rwd = str24+":"+str60+":"+str60; break;
		case 17: swd = "\\I";  rwd = str24+":"+str60+":"+str60; break;
		case 18: swd = "\\S1"; rwd = SLstr1;					break;
		case 19: swd = "\\S2"; rwd = SLstr2;					break;
		case 20: swd = "\\K1"; rwd = "[1122";				break;
		case 21: swd = "\\K2"; rwd = " ";				break;
		case 22: swd = "\\K3"; rwd = "Hފݖ HГ";			break;
		case 23: swd = "\\BP"; rwd = "100";						break;
		case 24: swd = "\\BT"; rwd = str24+":"+str60;			break;
		}
		int p;
		while ((p = s.Pos(swd)) != 0) {
			s.Delete(p, ((i==0) ? 12: swd.Length()));
			s.Insert(rwd, p);
		}
	}
	return cv->TextWidth(s);
}

//---------------------------------------------------------------------------
//^XNgCACR̍XV
//---------------------------------------------------------------------------
bool __fastcall TMClockForm::UpdateTrayIcon(DWORD dwMessage)
{
	if (TrayIcon1==NULL && (dwMessage==NIM_DELETE || DelayTrayIcon>0)) return true;

	bool ret = true;

	try {
		if (TrayIcon1==NULL) {
			TrayIcon1 = new TTrayIcon(this);
			TrayIcon1->OnMouseDown = TrayIcon1MouseDown;
			TrayIcon1->PopupMenu   = PopupMenu1;
		}

		if (hTrayIcon) {
			TrayIcon1->Icon->ReleaseHandle();
			::DestroyIcon(hTrayIcon);
			hTrayIcon = NULL;
		}
		TrayIcon1->Visible = false;
	}
	catch (...) {
		Sleep(1);
	}

	//̃}XN쐬
	if (ShowTrayIcon && (dwMessage==NIM_ADD || dwMessage==NIM_MODIFY)) {
		TRect rc = Rect(0, 0, 16, 16);
		std::unique_ptr<Graphics::TBitmap> msk(new Graphics::TBitmap());
		TCanvas *mcv = msk->Canvas;
		msk->SetSize(16, 16);
		msk->PixelFormat = pf1bit;
		mcv->Brush->Color	= clWhite;
		mcv->FillRect(rc);
		mcv->Brush->Color	= clBlack;
		mcv->Pen->Color 	= clBlack;
		mcv->Ellipse(0, 0, 16, 16);
		//̌`̉摜쐬
		std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		bmp->SetSize(16, 16);
		bmp->PixelFormat = pf4bit;
		TCanvas *ccv = bmp->Canvas;
		ccv->Brush->Color = ColShadow;
		ccv->FillRect(rc);
		ccv->Brush->Color = ColMoon;
		ccv->Pen->Color   = ColMoon;
		if (MoonInfo.phase<0.5)
			ccv->FillRect(Rect(8, 0, 16, 16));
		else
			ccv->FillRect(Rect(0, 0, 8, 16));
		int md = floor(8.0*(1.0-fabs(cos(M_PI*2.0*MoonInfo.phase))));
		if (MoonInfo.phase<=0.25 || MoonInfo.phase>=0.75) {
			ccv->Brush->Color = ColShadow;
			ccv->Pen->Color   = ColShadow;
		}
		else {
			ccv->Brush->Color = ColMoon;
			ccv->Pen->Color   = ColMoon;
		}
		ccv->Ellipse(md, 0, 16 - md, 16);
		ccv->CopyMode = cmSrcPaint;
		ccv->CopyRect(rc, mcv, rc);
		ccv->CopyMode = cmSrcInvert;
		ccv->CopyRect(rc, mcv, rc);

		//ACR쐬
		ICONINFO IcoInf;
		IcoInf.fIcon	= TRUE;
		IcoInf.xHotspot = 0;
		IcoInf.yHotspot = 0;
		IcoInf.hbmMask	= msk->Handle;
		IcoInf.hbmColor = bmp->Handle;
		hTrayIcon = ::CreateIconIndirect(&IcoInf);

		try {
			TrayIcon1->Icon->Handle = hTrayIcon;
			TrayIcon1->Hint 		= FormatDateTime("dddddd'('aaa')' t", CurTime);
			TrayIcon1->Visible		= ShowTrayIcon;
		} catch (...) {
			ret = false;
		}
	}

	return ret;
}


//---------------------------------------------------------------------------
//|bvAbvj[\OɌ݂̌擾čڂɐݒ
//---------------------------------------------------------------------------
void __fastcall TMClockForm::PopupMenu1Popup(TObject *Sender)
{
	UpdateMoonInfo();
	Info1Item->Caption = FormatDateTime("dddddd'('aaa')' t", CurTime);
	UnicodeString k_str = Koyomi->GetInfoStr(CurYear, CurMon, CurDay);
	UnicodeString tmpstr;
	Info2Item->Caption = tmpstr.cat_sprintf(_T("%s"), ReplaceStr(k_str, "\t", " ").c_str());
	Info3Item->Caption = tmpstr.sprintf(_T(": %5.2f/  Pʔ: %6.2f%%"),
							MoonInfo.age, MoonInfo.illuminated*100.0);

	Info3Item->Caption += ((MoonInfo.phase<0.50) ? "" : "");
	if (MoonInfo.next_full<MoonInfo.next_new)
		Info4Item->Caption = "̖ " + FormatDateTime("ddddd'('aaa')' hh''",MoonInfo.next_full);
	else
		Info4Item->Caption = "̐V " + FormatDateTime("ddddd'('aaa')' hh''",MoonInfo.next_new);
	if (MoonInfo.next_full<MoonInfo.next_new)
		Info5Item->Caption = "̐V " + FormatDateTime("ddddd'('aaa')' hh''",MoonInfo.next_new);
	else
		Info5Item->Caption = "̖ " + FormatDateTime("ddddd'('aaa')' hh''",MoonInfo.next_full);

	CalX = Mouse->CursorPos.x;
	CalY = Mouse->CursorPos.y;
	CaiItmHi = 0;

	CalYear = CurYear;
	CalMon	= CurMon;

	//INIt@Căj[ڂݒ
	for (int i=0; i<10; i++) IniFilItem[i]->Visible = false;
	TSearchRec sr;
	int i = 0;
	if (FindFirst(ExePath+"*.INI", 0, sr) == 0) {
		do {
			if (CompareText(ExtractFileName(IniFile->FileName), sr.Name) != 0) {
				TMenuItem *mp = IniFilItem[i++];
				mp->Caption = sr.Name.SubString(1, sr.Name.Length() - 4);
				mp->Visible = true;
			}
		} while (FindNext(sr)==0 && i<10);
	    FindClose(sr);
	}
	ChgIniItem->Visible = (i>0);
}

//---------------------------------------------------------------------------
//|bvAbv̌`
//---------------------------------------------------------------------------
void __fastcall TMClockForm::InfoItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, TRect &ARect, bool Selected)
{
	TMenuItem *tp =(TMenuItem*)Sender;
	ACanvas->Brush->Color = clBlack;
	ACanvas->FillRect(ARect);
	ACanvas->Font->Color = (tp->Tag==1) ? clAqua : clWhite;
	ACanvas->TextOut(ARect.Left + 6, ARect.Top + 2, tp->Caption);

	switch (tp->Tag) {
	case 1:
		::DrawEdge(ACanvas->Handle, &ARect, BDR_SUNKENOUTER, BF_TOP|BF_LEFT|BF_RIGHT); break;
	case 5:
		::DrawEdge(ACanvas->Handle, &ARect, BDR_SUNKENOUTER, BF_BOTTOM|BF_LEFT|BF_RIGHT); break;
	default:
		if (tp->Tag>0) ::DrawEdge(ACanvas->Handle, &ARect, BDR_SUNKENOUTER, BF_LEFT|BF_RIGHT);
	}
}
//---------------------------------------------------------------------------
void __fastcall TMClockForm::PopMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	//ڂ̍𒲐
	if (((TComponent *)Sender)->Tag==5) Height += Height/2;
}

//---------------------------------------------------------------------------
//}EXJ[\ɂƉB鏈
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	if (!HideClock && MouseHide && !Shift.Contains(ssShift)) Hide();
}
//---------------------------------------------------------------------------
//^XNgCACRENbNj[o
//  tH[̉ENbNj[oȂȂ錻ۂւ̑Ώ
//  (TTrayIcon AutoPopup=false ɂĂ܂)
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	PopupMenu1->AutoPopup = true;
}

//---------------------------------------------------------------------------
void __fastcall TMClockForm::TrayIcon1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Application->BringToFront();
}

//---------------------------------------------------------------------------
// ^C}[ (Interval = 100ms)
//---------------------------------------------------------------------------
void __fastcall TMClockForm::Timer1Timer(TObject *Sender)
{
	if (!HideClock) {
		//őOʏԂ͂ꂽꍇ̑Ώ
		if (StayOnTop) {
			if ((::GetWindowLong(Handle, GWL_EXSTYLE)&WS_EX_TOPMOST)==0)
				::SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		}
		//}EXŉBꂽv̕A
		if (!Visible && !BoundsRect.PtInRect(Mouse->CursorPos)) {
			Show();
			//}`fBXv[ŃbZ[W\
			//@AʒuςĂ܂sւ̑Ώ()
			Left = OrgLeft;
			Top  = OrgTop;
		}
	}
	//݂̎擾
	UpdateNow();

	//tς
	if (CurCount<LstCount) {
		CurHoliday->InitTable(CurYear);
		InitEventTable();
	}

	int  ev_stt = 0;
	bool u_flag = false;	//vʍXVtO

	//bω
	if (CurCount != LstCount) {
		//Cxg̏
		long cnt;
		long nxtcnt = 99999;
		for (int i=0; i<EvtTbSize; i++) {
			evnt_tbl *ep = &EventTable[i];
			if (!ep->active) continue;
			cnt = (ep->evtyp==EVT_ALARM) ? CurCount : (::GetTickCount()/1000L - ep->start);
			long dcnt = ep->count - cnt;	//Cxg܂ł̎cJEg
			if (dcnt > 0) {
				if (dcnt < nxtcnt) nxtcnt = dcnt;
				continue;
			}
			if (dcnt < -5) continue;		//^C}[񂾏ꍇ̃z[
			if (ep->done==1) continue;
			//ANVs
			ev_stt |= DoEventAction(i);
		}
		LstCount = CurCount;
		if (nxtcnt==99999) nxtcnt = 0;
		NxtDwnCount = nxtcnt;

		//񉹂̌JԂĐ
		if (BeatCount>0) {
			BeatCount--;
			if (BeatCount%BeatInterval == 0) PlayEventSound("Hour");
		}
		u_flag = SecUpdate;

		//gCACR̒x쐬
		if (DelayTrayIcon>0) {
			DelayTrayIcon--;
			if (DelayTrayIcon==0) {
				if (ShowTrayIcon) {
					if (!UpdateTrayIcon(NIM_ADD) && RetryTrayIcon>0) {
						RetryTrayIcon--;
						DelayTrayIcon = 60;	//sꍇ1ɃgC
					}
				}
			}
		}
	}

	//ω
	if (CurMin != LstMin) {
		//20ɌXV
		if ((CurMin % 20)==0) UpdateMoonInfo();

		//
		if ((ev_stt & EVST_SOUND)==0) {		//Cxgɂ͎炳Ȃ
			//00
			if (CurMin==0) {
				PlayEventSound("Hour");
				//JԂĐ̐ݒ
				if (BeatInterval>0) {
					BeatCount = CurHour % 12;
					if (BeatCount==0) BeatCount = 12;
					BeatCount--;
					BeatCount *= BeatInterval;
				}
				else
					BeatCount = 0;
			}
			//30
			else if (CurMin==30) {
				if (!PlayEventSound("Half")) PlayEventSound("Quart");
			}
			//15,45
			else if (CurMin==15 || CurMin==45)
				PlayEventSound("Quart");
		}
		//ǎύX
		//CxgŊɕύXĂ疳
		if ((ev_stt & EVST_WLPAPER)==0) {
			//00
			if (CurMin==0)
				ChangeWallPaper("Hour");
			//30
			else if (CurMin==30) {
				if (!ChangeWallPaper("Half")) ChangeWallPaper("Quart");
			}
			//15,45
			else if (CurMin==15 || CurMin==45)
				ChangeWallPaper("Quart");
		}

		//^XNgCACRXV
		UpdateTrayIcon(NIM_MODIFY);

		LstMin = CurMin;
		u_flag = true;
	}

	if (u_flag) Repaint();
}

//---------------------------------------------------------------------------
//_uNbN
//---------------------------------------------------------------------------
void __fastcall TMClockForm::FormDblClick(TObject *Sender)
{
	int evn = EV_DBLCLICK_BAS;
	if (is_KeyDown(VK_SHIFT))   evn |= 1;
	if (is_KeyDown(VK_CONTROL)) evn |= 2;
	if (is_KeyDown(VK_MENU))	evn |= 4;

	if (DoEventAction(evn)==0) {
		IniFile->LoadValues();
		RecyclePrc(Sender);
		AlmMsgForm->RecyclePrc(NULL);
		Repaint();
	}
}

//---------------------------------------------------------------------------
// ݒ̍ēǍ
//---------------------------------------------------------------------------
void __fastcall TMClockForm::RecyclePrc(TObject *Sender)
{
	Timer1->Enabled = false;

	//o[W`FbN
	UnicodeString sct = "General";
	int vno = IniFile->ReadInteger(sct, "Version", VersionNo);
	if (vno<VersionNo) {
		//VɒǉꂽL[쐬
		if (vno<140) {
			IniFile->WriteBool(	  sct, "ShowKoyomiTip",	true);
			IniFile->WriteBool(	  sct, "ShowScheduleTip",false);
		}
		if (vno<155) {
			IniFile->WriteBool(	  sct, "ShowChangeYear",	false);
		}

		IniFile->WriteInteger(sct, "Version", VersionNo);	//o[WԍXV
		IniFile->UpdateFile();
	}

	//\胊Xg̓ǂݍ
	ScheduleList1->Clear();
	UnicodeString file_name = IniFile->ReadString(sct, "ScheduleList1");
	if (get_file_name_r(file_name)) ScheduleList1->LoadFromFile(file_name);
	ScheduleList2->Clear();
	file_name = IniFile->ReadString(sct, "ScheduleList2");
	if (get_file_name_r(file_name)) ScheduleList2->LoadFromFile(file_name);

	ShowKoyomiTip	= IniFile->ReadBool(sct, "ShowKoyomiTip",	true);
	ShowScheduleTip = IniFile->ReadBool(sct, "ShowScheduleTip",	false);
	ShowChangeYear	= IniFile->ReadBool(sct, "ShowChangeYear",	false);
	CalDispItem[18]->Visible = ShowChangeYear;
	CalDispItem[37]->Visible = ShowChangeYear;
	CalDispItem[19]->Break	 = mbBarBreak;

	//zF
	Color	  = IniFile->ReadColor(sct, "BgColor", 	DEF_BgColor);
	ColFrame  = IniFile->ReadColor(sct, "FrmColor",	DEF_FrmColor);
	ColMoon   = IniFile->ReadColor(sct, "MonColor",	DEF_MonColor);
	ColShadow = IniFile->ReadColor(sct, "ShdColor",	DEF_ShdColor);

	//ԏɕ\邩
	StayOnTop = IniFile->ReadBool(sct, "StayOnTop",	true);
	::SetWindowPos(Application->Handle,
		(StayOnTop ? HWND_TOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	FormStyle = StayOnTop ? fsStayOnTop : fsNormal;

	//Alt+Tab؂ւ̎ɃAvƂĕ\邩
	HideApp = IniFile->ReadBool(sct, "hideApplication", true);

	::ShowWindow(Application->Handle, HideApp? SW_HIDE : SW_SHOW);

	LONG w_style = ::GetWindowLong(Application->Handle, GWL_EXSTYLE);
	if (HideApp) w_style |= WS_EX_TOOLWINDOW; else w_style &= ~WS_EX_TOOLWINDOW;
	::SetWindowLong(Application->Handle, GWL_EXSTYLE, w_style);

	w_style = ::GetWindowLong(Handle, GWL_EXSTYLE);
	if (HideApp) w_style |= WS_EX_TOOLWINDOW; else w_style &= ~WS_EX_TOOLWINDOW;
	::SetWindowLong(Handle, GWL_EXSTYLE, w_style);

	//
	TransAlpha = IniFile->ReadInteger(sct, "Transparent", -1);
	if (TransAlpha>=0 && TransAlpha<=255) {
		//wi̓
		if (TransAlpha==0) {
			AlphaBlend			  = false;
			TransparentColor	  = true;
			TransparentColorValue = Color;
		}
		//
		else {
			TransparentColor = false;
			AlphaBlend		 = true;
			AlphaBlendValue  = TransAlpha;
		}
	}
	else {
		TransparentColor = false;
		AlphaBlend		 = false;
	}

	MouseHide	= IniFile->ReadBool(   sct, "MouseHide",	false);
	Hour12		= IniFile->ReadInteger(sct, "Hour12",		0);
	ShowSec 	= IniFile->ReadBool(   sct, "ShowSec",		false);
	ShowMoon	= IniFile->ReadInteger(sct, "ShowMoon",		1);
	MoonShading = IniFile->ReadBool(   sct, "MoonShading",	false);

	//\tHgݒ
	TimeFont->Charset = DEFAULT_CHARSET;
	TimeFont->Name	  = IniFile->ReadString( sct, "FontName", "lr SVbN");
	TimeFont->Size	  = IniFile->ReadInteger(sct, "FontSize", 16);
	TimeFont->Color   = IniFile->ReadColor(  sct, "FgColor", DEF_FgColor);
	TimeFont->Style   = TFontStyles();
	if (IniFile->ReadBool(sct, "FontBold",  false)) TimeFont->Style = TimeFont->Style << fsBold;
	if (IniFile->ReadBool(sct, "FontItalic",false)) TimeFont->Style = TimeFont->Style << fsItalic;
	FontShadow = IniFile->ReadInteger(sct, "FontShadow", 0);
	ColFntShd  = IniFile->ReadColor(  sct, "FsColor", 	DEF_FsColor);
	ColFntPly  = IniFile->ReadColor(  sct, "SpColor", 	TimeFont->Color);
	FsPosX	   = IniFile->ReadInteger(sct, "FsPosX",	1);
	FsPosY	   = IniFile->ReadInteger(sct, "FsPosY",	1);
	TimeAlign  = IniFile->ReadInteger(sct, "TimeAlign", 1);
	InfAlign   = IniFile->ReadInteger(sct, "InfAlign",	1);

	//̎Iȍ߂
	Canvas->Font->Assign(TimeFont);
	::GetTextMetrics(Canvas->Handle, &TmMetric);
	if (Hour12<6)
		TimeHeight = TmMetric.tmHeight - TmMetric.tmInternalLeading;
	else
		TimeHeight = TmMetric.tmHeight;

	//̍ő啝߂
	MaxMinSecWidth = GetMaxFormWidth(Canvas, ((ShowSec==1) ? "\\C": "\\t"));
	MaxTimeWidth   = MaxMinSecWidth;
	AmPmWidth = 0;
	if (Hour12>1) {
		AmPmYofs = 0;
		if (Hour12<6) {
			//am,pm/AM,PM \
			AmPmYofs = Canvas->TextHeight("A");
			Canvas->Font->Size = std::max(TimeFont->Size/2, 8);
			AmPmYofs -= (Canvas->TextHeight("A")*5/4);
		}
		AmPmXofs = (Canvas->TextWidth(" ")/2);
		switch (Hour12) {
		case 2: case 3: case 6: case 7:
			AmPmWidth = Canvas->TextWidth("am"); break;
		case 4: case 5: case 8: case 9:
			AmPmWidth = Canvas->TextWidth("AM"); break;
		}
		AmPmWidth += AmPmXofs;
		MaxTimeWidth += AmPmWidth;
		Canvas->Font->Size = TimeFont->Size;
	}

	//ǉ\tHgݒ
	int a_hi	= 0;
	MaxInfWidth = 0;
	InfFormat	= IniFile->ReadString(sct, "InfFormat");
	InfFormat2 = IniFile->ReadString(sct, "InfFormat2");
	if (!InfFormat.IsEmpty() || !InfFormat2.IsEmpty()) {
		InfFont->Charset = DEFAULT_CHARSET;
		InfFont->Name	 = IniFile->ReadString( sct, "InfFontName",	"lr SVbN");
		InfFont->Size	 = IniFile->ReadInteger(sct, "InfFontSize",	9);
		InfFont->Color	 = IniFile->ReadColor(  sct, "InfFgColor",	DEF_FgColor);
		ColInfShd		 = IniFile->ReadColor(  sct, "InfFsColor",	DEF_FsColor);
		InfFont->Style   = TFontStyles();
		if (IniFile->ReadBool(sct, "InfFontBold",  false)) InfFont->Style = InfFont->Style << fsBold;
		if (IniFile->ReadBool(sct, "InfFontItalic",false)) InfFont->Style = InfFont->Style << fsItalic;
		InfShadow = IniFile->ReadBool(   sct, "InfShadow", false);
		InfFsPosX = IniFile->ReadInteger(sct, "InfFsPosX", 1);
		InfFsPosY = IniFile->ReadInteger(sct, "InfFsPosY", 1);
		Canvas->Font->Assign(InfFont);
			MaxInfWidth = std::max(GetMaxFormWidth(Canvas, InfFormat), GetMaxFormWidth(Canvas, InfFormat2));
			a_hi = Canvas->TextHeight(" ");
			if (!InfFormat2.IsEmpty()) a_hi *= 2;
		Canvas->Font->Assign(TimeFont);
	}

	//vO`̕ݒ
	MoonSize = TimeHeight;
	MarginX  = IniFile->ReadInteger(sct, "MarginX",TimeHeight/8);
	MarginY  = IniFile->ReadInteger(sct, "MarginY",TimeHeight/4);
	if (ShowMoon<7) {
		int fw = IniFile->ReadInteger(sct, "FrmWidth",0);
		MarginX += fw;
		MarginY += fw;
	}
	int wd = std::max(MaxTimeWidth, ((ShowMoon==6) ? 0 : MaxInfWidth)) + MarginX*2;
	if (TimeFont->Style.Contains(fsItalic)) wd += TimeHeight/8;

	//vO`̍ݒ
	int hi = TimeHeight + a_hi + MarginY*2;
	switch (ShowMoon) {
	case 1: case 2: //E
		MoonSize += a_hi;
		wd += MoonSize + MoonSize/8;
		break;
	case 3: case 4:	//㉺
		MoonSize *= 2;
		hi += MoonSize + MoonSize/8;
		break;
	case 5:	case 6:	//Â
		MoonSize *= 2;
		hi = MoonSize + MarginY*2;
		break;
	case 7: case 8:	//O`=
		MoonSize = hi = wd;
		break;
	}
	Height = hi;
	Width  = wd;

	//vXʒu
	ErrFlag = false;
	int p = IniFile->ReadInteger(sct, "WinRightR",99999);
	if (p!=99999)
		Left = Screen->Width - Width + p;
	else {
		p = IniFile->ReadInteger(sct, "WinRight",99999);
		Left = (p!=99999) ? (p - Width) : IniFile->ReadInteger(sct, "WinLeft",50);
	}

	//vYʒu
	p = IniFile->ReadInteger(sct, "WinBottomR",99999);
	if (p!=99999)
		Top = Screen->Height - Height + p;
	else {
		p = IniFile->ReadInteger(sct, "WinBottom",99999);
		Top = (p!=99999) ? (p - Height) : IniFile->ReadInteger(sct, "WinTop",50);
	}
	//ʒũ`FbN
	if (!IniFile->ReadBool(sct, "PosNoCheck", false)) {
		if (Left>=Screen->Width) {
			Left = Screen->Width - Width;	ErrFlag = true;
		}
		if ((Left + Width)<=0) {
			Left = 0;	ErrFlag = true;
		}
		if (Top>=Screen->Height) {
			Top = Screen->Height - Height;	ErrFlag = true;
		}
		if ((Top + Height)<=0) {
			Top = 0;	ErrFlag = true;
		}
		if (ErrFlag)
			ErrText = "v̈ʒuw肪ʂ̊OɂȂĂ܂\nINIt@CmFĂ";
	}
	OrgLeft = Left;
	OrgTop	= Top;

	//vO`̃[W쐬
	SetWindowRgn(Handle, NULL, true);
	if (hFrmRegion) { ::DeleteObject(hFrmRegion); hFrmRegion = NULL; }
	if (hDrwRegion) { ::DeleteObject(hDrwRegion); hDrwRegion = NULL; }
	if (ShowMoon==7 || ShowMoon==8) {
		hFrmRegion = ::CreateEllipticRgn(0, 0, Width, Height);
		hDrwRegion = ::CreateEllipticRgn(0, 0, Width, Height);
		SetWindowRgn(Handle, hFrmRegion, true);
	}
	else {
		UnicodeString sp = IniFile->ReadString(sct, "Shape");
		int px = IniFile->ReadInteger(sct, "ShapePrmX", Height/4);
		int py = IniFile->ReadInteger(sct, "ShapePrmY", Height/4);
		//p̊ۂ`
		if (sp=="RoundRect") {
			hFrmRegion = ::CreateRoundRectRgn(0, 0, Width, Height, px*2, py*2);
			hDrwRegion = ::CreateRoundRectRgn(0, 0, Width, Height, px*2, py*2);
			SetWindowRgn(Handle, hFrmRegion, true);
		}
		//p`
		else if (sp=="OctRect") {
			POINT p[8];
			int i = 0;
			p[i++] = Point(px,			0);
			p[i++] = Point(Width - px,	0);
			p[i++] = Point(Width,		py);
			p[i++] = Point(Width,		Height - py);
			p[i++] = Point(Width - px,	Height);
			p[i++] = Point(px,			Height);
			p[i++] = Point(0,			Height - py);
			p[i++] = Point(0,			py);
			hFrmRegion = ::CreatePolygonRgn(p, i, WINDING);
			hDrwRegion = ::CreatePolygonRgn(p, i, WINDING);
			SetWindowRgn(Handle, hFrmRegion, true);
	 	}
	}

	//̉摜ݒ
	MoonImage->Handle = NULL;
	MoonImage->SetSize(MoonSize, MoonSize);
	if (MoonShading) MoonImage->PixelFormat = pf24bit;
	MoonImage->Canvas->Brush->Color = ColMoon;
	MoonImage->Canvas->Pen->Color   = ColMoon;
	file_name = IniFile->ReadString(sct, "MoonImage");
	try {
		if (!get_file_name_r(file_name)) throw Exception(EmptyStr);
		std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		if (!WIC_load_image(file_name, bmp.get())) throw Exception(EmptyStr);
		if (!WIC_resize_image(bmp.get(), MoonImage,  0.0, MoonSize, MoonSize)) throw Exception(EmptyStr);
	}
	catch (...) {
		MoonImage->Canvas->FillRect(Rect(0, 0, MoonSize, MoonSize));
	}

	//ẻ摜ݒ
	ShadowImage->Handle = NULL;
	ShadowImage->SetSize(MoonSize, MoonSize);
	if (MoonShading) ShadowImage->PixelFormat = pf24bit;
	ShadowImage->Canvas->Brush->Color = ColShadow;
	ShadowImage->Canvas->Pen->Color   = ColShadow;
	file_name = IniFile->ReadString(sct, "ShadowImage");
	try {
		if (!get_file_name_r(file_name)) throw Exception(EmptyStr);
		std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
		if (!WIC_load_image(file_name, bmp.get())) throw Exception(EmptyStr);
		if (!WIC_resize_image(bmp.get(), ShadowImage, 0.0, MoonSize, MoonSize)) throw Exception(EmptyStr);
	}
	catch (...) {
		ShadowImage->Canvas->FillRect(Rect(0, 0, MoonSize, MoonSize));
	}

	//wi摜̓ǂݍ
	if (ShowMoon<7) {
		BgImage->Handle = NULL;
		file_name = IniFile->ReadString(sct, "BgImage");
		if (get_file_name_r(file_name)) WIC_load_image(file_name, BgImage);
	}

	//eXg̓o^JEg
	WallPaperPrm->IniFile = IniFile;
	WallPaperPrm->AutoRegister("*.bmp;*.jpg;*.png;*.gif");
	WallPaperPrm->CountList();
	SoundPrm->IniFile = IniFile;
	SoundPrm->AutoRegister(IniFile->ReadString("SoundList", "AutoRegMask", "*.wav"));
	SoundPrm->CountList();
	MessagePrm->IniFile = IniFile;
	MessagePrm->AutoRegister("");
	MessagePrm->CountList();

	//\̏
	TestMoonAage	 = IniFile->ReadFloat("Test", "MoonAge", -1.0);
	UnicodeString testt = IniFile->ReadString("Test", "Time");
	TestTime = testt.IsEmpty() ? TDateTime(0.0) : StrToDateTime(testt);
	UpdateNow();
	CurHoliday->InitTable(CurYear);
	LstCount = -1;
	LstMin	 = -1;
	NxtDwnCount = 0;
	StartCount	= ::GetTickCount()/1000L;
	UpdateMoonInfo();
	CalMoonTime = (unsigned short)IniFile->ReadInteger(sct, "CalMoonTime", 21);
	if (CalMoonTime>23) CalMoonTime = 21;

	//񉹌JԂ
	BeatInterval = IniFile->ReadInteger("Hour", "BeatInterval", 0);

	//SNTPT[ow
	SNTPC->ServerName = IniFile->ReadString("TimeAdjust", "Server", EmptyStr);

	//Cxg`e[u̍쐬
	EvtTbSize = 0;
	for (int i=0; i<MAX_ALARM; i++)
		EvtTbSize = ReadEventCfg("Alarm" + IntToStr(i + 1), EVT_ALARM, EvtTbSize);
	for (int i=0; i<MAX_WIN_TIMER; i++)
		EvtTbSize = ReadEventCfg("WinTimer"+IntToStr(i + 1), EVT_WIN_TIMER, EvtTbSize);
	for (int i=0; i<MAX_START_TIMER; i++)
		EvtTbSize = ReadEventCfg("StartTimer" + IntToStr(i + 1), EVT_START_TIMER, EvtTbSize);
	for (int i=0; i<MAX_INTERVAL_TIMER; i++)
		EvtTbSize = ReadEventCfg("IntervalTimer" + IntToStr(i + 1), EVT_INTERVAL_TIMER, EvtTbSize);

	InitEventTable();

	SecUpdate = (ShowSec>0 ||
					InfFormat.Pos("\\C")>0 || InfFormat.Pos("\\R")>0 || InfFormat.Pos("\\I")>0 ||
					InfFormat2.Pos("\\C")>0 || InfFormat2.Pos("\\R")>0 || InfFormat2.Pos("\\I")>0);
	Started = true;
	randomize();

	//v̔\
	HideClock = IniFile->ReadBool(sct, "HideClock",	false);

	//^XNgCACR
	ShowTrayIcon  = IniFile->ReadBool(sct, "TrayIcon", false);
	DelayTrayIcon = 0;
	if (!UpdateTrayIcon(ShowTrayIcon? NIM_ADD : NIM_DELETE)) {
		DelayTrayIcon = 10;
		RetryTrayIcon = 10;
	}

	Timer1->Enabled = true;

	if (ErrFlag) {
		Application->MessageBox(ErrText.c_str(), _T("x"), MB_OK + MB_ICONWARNING);
		ErrFlag = false;
	}
}


//---------------------------------------------------------------------------
//ݒt@Cؑ
//---------------------------------------------------------------------------
void __fastcall TMClockForm::IniFilItemClick(TObject *Sender)
{
 	TMenuItem *mp = (TMenuItem *)Sender;
	if (FileExists(ExePath + mp->Caption + ".INI")) {
		IniFile->Reload(ExePath + mp->Caption + ".INI");
		RecyclePrc(NULL);
		AlmMsgForm->RecyclePrc(NULL);
		Repaint();
	}
}
//---------------------------------------------------------------------------
// ݒt@C̕ҏW
//---------------------------------------------------------------------------
void __fastcall TMClockForm::EditItemClick(TObject *Sender)
{
	UnicodeString editor = IniFile->ReadString("General", "Editor", "notepad.exe");
	if (!editor.IsEmpty()) {
		IniFile->UpdateFile();
		UnicodeString fnam = IniFile->FileName;
		if (fnam.Pos(" ")!=0) fnam = "\""+fnam+"\"";
		::ShellExecute(NULL, _T("open"), editor.c_str(), fnam.c_str(), NULL, SW_SHOWNORMAL);
	}
}

//---------------------------------------------------------------------------
// ݒt@C̍ēǍ (_uNbN)
//---------------------------------------------------------------------------
void __fastcall TMClockForm::RecycleItemClick(TObject *Sender)
{
	IniFile->LoadValues();
	RecyclePrc(Sender);
	AlmMsgForm->RecyclePrc(NULL);
	Repaint();
}

//---------------------------------------------------------------------------
// I
//---------------------------------------------------------------------------
void __fastcall TMClockForm::QuitItemClick(TObject *Sender)
{
	Close();
}

//---------------------------------------------------------------------------
// WM_MCLK_RECYCLE bZ[W
//---------------------------------------------------------------------------
void __fastcall TMClockForm::WmMclkRecycle(TMessage& msg)
{
	IniFile->LoadValues();
	RecyclePrc(NULL);
	AlmMsgForm->RecyclePrc(NULL);
	Repaint();
	msg.Result = 0;
}

//---------------------------------------------------------------------------
//dNꂽ MClock R}hC̓e󂯎
//---------------------------------------------------------------------------
void __fastcall TMClockForm::WmCopyData(TMessage& msg)
{
	COPYDATASTRUCT *cd = (COPYDATASTRUCT*)(msg.LParam);
	if (cd->dwData==1) {
		//R}hC̉
		UnicodeString clbuf = (LPTSTR)cd->lpData;
		if (clbuf.SubString(1, 1)=="-") {
			bool r_flag = false;
			if (clbuf.SubString(2, 1)=="R") {
				//ݒēǍ
				IniFile->LoadValues();
				r_flag = true;
			}
			else if (clbuf.SubString(2, 1)=="I") {
				//INIt@C؂ւ
				clbuf.Delete(1, 2).Trim();
				if (FileExists(ExePath + clbuf)) {
					IniFile->Reload(ExePath + clbuf);
					r_flag	= true;
				}
			}
			if (r_flag) {
				RecyclePrc(NULL);
				AlmMsgForm->RecyclePrc(NULL);
				Repaint();
			}
		}
	}
	msg.Result = 0;
}

//---------------------------------------------------------------------------
// Cxgݒ̓Ǎ
//---------------------------------------------------------------------------
int __fastcall TMClockForm::ReadEventCfg(const UnicodeString sct, int typ, int tidx)
{
	UnicodeString tbuf = IniFile->ReadString(sct, "Time");
	if (!tbuf.IsEmpty()) {
		evnt_tbl *ep = &EventTable[tidx];
		ep->evtyp = typ;
		ep->name  = sct;

		int h = StrToIntDef(tbuf.SubString(1, 2), 0);
		int m = StrToIntDef(tbuf.SubString(4, 2), 0);
		int s = StrToIntDef(tbuf.SubString(7, 2), 0);
		ep->count = h*3600L + m * 60 + s;

		if (typ==EVT_START_TIMER || typ==EVT_INTERVAL_TIMER)
			ep->start = StartCount;
		else
			ep->start = 0;

		ep->dt_msk = IniFile->ReadString(sct, "DateMask");
		ep->wk_msk = IniFile->ReadString(sct, "WeekMask");

		if (Started) {
			if (!IniFile->ReadBool(sct, "StartOnly")) ep->done = false;
		}
		else
			ep->done = false;

		if (typ==EVT_START_TIMER) {
			if (IniFile->ReadBool(sct, "OnceDay")) {
				//
				tbuf = IniFile->ReadString(sct, "LastAction");
				if (!tbuf.IsEmpty()) {
					if ((int)StrToDateTime(tbuf)==(int)CurTime) ep->done = true;
				}
			}
		}

		ep->active = true;
		tidx++;
	}
	return tidx;
}

//---------------------------------------------------------------------------
// Cxge[u
//---------------------------------------------------------------------------
void __fastcall TMClockForm::InitEventTable()
{
	UnicodeString DateStr = FormatDateTime("yyyy/mm/dd",CurTime);

	for (int i=0; i<EvtTbSize; i++) {
		evnt_tbl *ep = &EventTable[i];

		//A[ done tOZbg
		if (ep->evtyp==EVT_ALARM) ep->done = false;

		//t}XÑ`FbN
		bool dflag = true;
		if (!ep->dt_msk.IsEmpty()) {
			if (ep->dt_msk.Length()==10) {
				int p = 1;
				while (p<=10) {
					if (p==5 || p==8) {
						p++; continue;
					}
					else {
						if (ep->dt_msk[p]!='X') {
							if (ep->dt_msk[p] != DateStr[p]) {
								dflag = false; break;
							}
						}
						p++;
					}
				}
			}
		}
		if (!dflag) {
			ep->active = false; continue;
		}

		//j}XÑ`FbN
		if (ep->wk_msk.IsEmpty())
			ep->active = true;
		else {
			bool wflag = false;
			int p = ep->wk_msk.Pos(WeekStrJ[CurWek - 1]);
			if (p>1) {
				char c = ep->wk_msk[p - 1];
				switch(c) {
				case 'W':
					wflag = true; break;
				case '1': case '2': case '3': case '4': case '5':
					wflag = (CurDay == get_wday(CurYear, CurMon, CurWek, (c - 0x30)));
					break;
				}
			}
			if (ep->wk_msk.Pos("H+")>0)
				ep->active = (wflag || CurHoliday->IsHoliday(CurYear, CurMon, CurDay, NULL));
			else if (ep->wk_msk.Pos("H-")>0)
				ep->active = (wflag && !CurHoliday->IsHoliday(CurYear, CurMon, CurDay, NULL));
			else
				ep->active = wflag;
		}
	}
}

//---------------------------------------------------------------------------
// Cxg炷
// 	ev_id:  Cxg̃ZNV
//  ߂l: ĐJn true
//---------------------------------------------------------------------------
bool __fastcall TMClockForm::PlayEventSound(const UnicodeString ev_id)
{
	UnicodeString param;
	if (!SoundPrm->GetParam(ev_id, param)) return false;

	//Đ~߂
	if (SoundPlaying) {
		::mciSendString(_T("stop EventSound"), NULL, 0, NULL);
		::mciSendString(_T("close EventSound"), NULL, 0, NULL);
		SoundPlaying = false;
	}

	if (!get_file_name_r(param)) return false;
	if (param.Pos(" ")!=0) param = "\""+param+"\"";

	//Đt@CJ
	UnicodeString cmdstr = "open " +  param + " alias EventSound";
	if (::mciSendString(cmdstr.c_str(), NULL, 0, Handle)!=0) return false;

	//Đ\
	_TCHAR rbuf[21];
    mciSendString(_T("capability EventSound can play wait"), rbuf, 20, NULL);
	if (_tcscmp(rbuf, _T("true"))!=0) {
		::mciSendString(_T("close EventSound"), NULL, 0, NULL);
		return false;
	}

	//ĐJn
	SoundPlaying = true;
	::mciSendString(_T("play EventSound notify"), NULL, 0, Handle);
	Repaint();
	return true;
}

//---------------------------------------------------------------------------
// MM_MCINOTIFY bZ[W
// CxgĐI
//---------------------------------------------------------------------------
void __fastcall TMClockForm::WmMciNotify(TMessage& msg)
{
	if (msg.WParam==MCI_NOTIFY_SUCCESSFUL) {
		if (SoundPlaying) {
			::mciSendString(_T("close EventSound"), NULL, 0, NULL);
			SoundPlaying = false;
			Repaint();
		}
	}
	msg.Result = 0;
}

//---------------------------------------------------------------------------
// ǎ̕ύX
//  ev_id:  Cxg̃ZNV
//  ߂l: ǎw肳Ă true
//---------------------------------------------------------------------------
bool __fastcall TMClockForm::ChangeWallPaper(const UnicodeString ev_id)
{
	UnicodeString param;
	if (!WallPaperPrm->GetParam(ev_id, param)) return false;

	if (param.IsEmpty()) {
		::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, (LPVOID)_T(""),
			SPIF_UPDATEINIFILE|SPIF_SENDWININICHANGE);
	}
	else if (get_file_name_r(param)) {
		UnicodeString wpfnam = IniFile->ReadString("General","WallBmpName", ExePath+"MClkWall.BMP");
		UnicodeString wpfext = ExtractFileExt(param).UpperCase();
		bool flag = false;
		if (wpfext==".JPG" || wpfext==".PNG" || wpfext==".GIF") {
			std::unique_ptr<Graphics::TBitmap> bmpimg(new Graphics::TBitmap());
			if (WIC_load_image(param, bmpimg.get())) {
				bmpimg->SaveToFile(wpfnam);
				flag = true;
			}
		}
		else if (wpfext==".BMP") {
			flag = ::CopyFile(param.c_str(), wpfnam.c_str(), FALSE);
		}
		if (flag) {
			::SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, wpfnam.c_str(),
				SPIF_UPDATEINIFILE|SPIF_SENDWININICHANGE);
		}
	}
	return true;
}

//---------------------------------------------------------------------------
// bZ[W\
// 	ev_id:  Cxg̃ZNV
//  ߂l: bZ[Ww肳Ă true
//---------------------------------------------------------------------------
bool __fastcall TMClockForm::ShowMsgBoard(const UnicodeString ev_id)
{
	UnicodeString param;
	if (!MessagePrm->GetParam(ev_id, param)) return false;
	AlmMsgForm->LastActWnd = ::GetForegroundWindow();
	AlmMsgForm->Hide();
	AlmMsgForm->MsgText   = param;
	AlmMsgForm->BgImgFile = IniFile->ReadString(ev_id, "MsgBgImage");
	AlmMsgForm->Show();
	::SetWindowPos(AlmMsgForm->Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	::SetForegroundWindow(AlmMsgForm->Handle);
	return true;
}

//---------------------------------------------------------------------------
// Cxg̃ANVs
// evn: Cxg`e[u
//---------------------------------------------------------------------------
int __fastcall TMClockForm::DoEventAction(const int evn)
{
	int ret = 0;

	evnt_tbl *ep;
	UnicodeString sct;
	if (evn>=0 && evn<EvtTbSize) {
		ep	= &EventTable[evn];
		sct = ep->name;
		if (ep->evtyp==EVT_INTERVAL_TIMER) ep->start = ::GetTickCount()/1000L;
	}
	else {
		ep	= NULL;
		sct = EmptyStr;
		if (evn>=EV_DBLCLICK_BAS) {
			//_uNbNECxg
			sct = "DblClick";
			if (evn>EV_DBLCLICK_BAS) sct += IntToStr(evn - EV_DBLCLICK_BAS);
		}
	}
	if (sct.IsEmpty()) return ret;

	//TEh
	if (PlayEventSound(sct)) ret |= EVST_SOUND;

	//vwi̕ύX
	UnicodeString file_name = IniFile->ReadString(sct, "BgImage");
	if (ShowMoon<7 && get_file_name_r(file_name)) {
		BgImage->Handle = NULL;
		WIC_load_image(file_name, BgImage);
		Repaint();
		ret |= EVST_BG_IMG;
	}

	//ǎ̕ύX
	if (ChangeWallPaper(sct)) ret |= EVST_WLPAPER;

	//bZ[W
	if (ShowMsgBoard(sct)) ret |= EVST_MESSAGE;

	//AvP[V̎s
	file_name = IniFile->ReadString(sct, "Execute");
	if (!file_name.IsEmpty()) {
		UnicodeString param  = IniFile->ReadString(sct, "Param");
		UnicodeString ExePath = IniFile->ReadString(sct, "WkDir");
		::ShellExecute(NULL, _T("open"), file_name.c_str(), param.c_str(), ExePath.c_str(), SW_SHOWNORMAL);
		ret |= EVST_EXECUTE;
	}

	if (ep!=NULL) {
		if (ep->evtyp != EVT_INTERVAL_TIMER) ep->done = true;
		if (ep->evtyp == EVT_START_TIMER) {
			if (IniFile->ReadBool(sct, "OnceDay")) {
				IniFile->WriteString(sct, "LastAction", FormatDateTime("c", CurTime));
				IniFile->UpdateFile();
			}
		}
	}

	//R}h̎s
	UnicodeString cmd = IniFile->ReadString(sct, "Command");
	if (!cmd.IsEmpty()) {
		//\
		if (cmd=="CALENDER") {
			CalX = Mouse->CursorPos.x;
			CalY = Mouse->CursorPos.y;
			CalYear = CurYear;
			CalMon	= CurMon;
			CalItemClick(NULL);
		}
		//킹
		else if (cmd=="TIMEADJUST") {
			if (Has_SE_SYSTIME)
				TimeAdjustAction->Execute();
			else {
				IniFile->WriteString("TimeAdjust", "LastError",
					FormatDateTime("yy/mm/dd hh:nn:ss ύX̌܂", Now()));
				IniFile->UpdateFile();
				//o[\
				if (TrayIcon1) {
					TrayIcon1->BalloonFlags = bfInfo;
					TrayIcon1->BalloonTitle = "킹";
					TrayIcon1->BalloonHint	= "ύX̌܂";
					TrayIcon1->ShowBalloonHint();
				}
			}
		}
		//XN[ZCo[N
		else if (cmd=="SCREENSAVE") {
			BOOL act = FALSE;
			if (::SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, &act, 0) == TRUE) {
				if (act) ::SendMessage(Handle, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
			}
		}
		//Vbg_E
		else if (cmd=="REBOOT" || cmd=="LOGOFF" || cmd=="POWEROFF") {
			//L
			bool ok = false;
			HANDLE hToken;
			if (::OpenProcessToken(::GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken)) {
				TOKEN_PRIVILEGES tknPrvlgs;
				if (::LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &(tknPrvlgs.Privileges[0].Luid))) {
					tknPrvlgs.PrivilegeCount = 1;
					tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
					::AdjustTokenPrivileges(hToken, FALSE, &tknPrvlgs, sizeof(TOKEN_PRIVILEGES), NULL, NULL);
					ok = (GetLastError()==ERROR_SUCCESS);
				}
				::CloseHandle(hToken);
			}
			if (ok) {
				if (cmd=="REBOOT")
					::ExitWindowsEx(EWX_REBOOT,   0);	//ċN
				else if (cmd=="LOGOFF")
					::ExitWindowsEx(EWX_LOGOFF,   0);	//OIt
				else
					::ExitWindowsEx(EWX_POWEROFF, 0);	//I
			}
		}
		ret |= EVST_COMMAND;
	}

	return ret;
}
//---------------------------------------------------------------------------
//Nbv{[hɃRs[
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CopyItemClick(TObject *Sender)
{
	Clipboard()->AsText
		 = Info1Item->Caption+"\r\n" +
		   Info2Item->Caption+"\r\n" +
		   Info3Item->Caption+"\r\n" +
		   Info4Item->Caption+"\r\n" +
		   Info5Item->Caption+"\r\n";
}
//---------------------------------------------------------------------------
//킹
//---------------------------------------------------------------------------
void __fastcall TMClockForm::TimeAdjustActionExecute(TObject *Sender)
{
	Screen->Cursor = crHourGlass;
	UnicodeString msg_str = EmptyStr;
	if (SNTPC->TimeAdjust()) {
		TDateTime def = SNTPC->AdjTime - SNTPC->OrgTime;
		msg_str += FormatDateTime("yy/mm/dd hh:nn:ss", SNTPC->OrgTime);
		msg_str.UCAT_TSTR(" --> ");
		msg_str += FormatDateTime("hh:nn:ss", SNTPC->AdjTime);
		msg_str.UCAT_TSTR(" (");
		msg_str += ((double)def>0.0)? "+" : "-";
		msg_str += FormatDateTime("hh:nn:ss.zzz", def);
		msg_str.UCAT_TSTR(")");
		IniFile->WriteString("TimeAdjust", "LastAdjust", msg_str);
	}
	else {
		msg_str = FormatDateTime("yy/mm/dd hh:nn:ss ", Now()) + SNTPC->ErrMsg;
		IniFile->WriteString("TimeAdjust", "LastError", msg_str);
	}
	IniFile->UpdateFile();

	//ʂo[qgŕ\
	if (TrayIcon1) {
		TrayIcon1->BalloonFlags = bfInfo;
		TrayIcon1->BalloonTitle = "킹";
		TrayIcon1->BalloonHint	= msg_str;
		TrayIcon1->ShowBalloonHint();
	}

	Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TMClockForm::TimeAdjustActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = Has_SE_SYSTIME && !SNTPC->ServerName.IsEmpty();
}
//---------------------------------------------------------------------------
//J_[\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalItemClick(TObject *Sender)
{
	//je[uݒ
	CalHoliday->InitTable(CalYear);

	//ڂɕݒ
	int d = 1;
	for (int i=0; i<38; i++) {
		TMenuItem *mp = CalDispItem[i];
		switch (i) {
		case 0:
			mp->Caption = UnicodeString().sprintf(_T("%4uN %2u@@%02u:00JST"), CalYear, CalMon, CalMoonTime);
			mp->Tag 	= -1;
			break;
		case 16: case 19:
			mp->Tag 	= -1;
			break;
		case 17:
			mp->Caption = "@Ǒ";
			mp->OnClick = CalPrevMItemClick;
			mp->Tag 	= -2;
			break;
		case 18:
			mp->Caption = "@O̔N";
			mp->OnClick = CalPrevYItemClick;
			mp->Tag 	= -3;
			break;
		case 36:
			mp->Caption = "@̌";
			mp->OnClick = CalNextMItemClick;
			mp->Tag 	= -2;
			break;
		case 37:
			mp->Caption = "@̔N";
			mp->OnClick = CalNextYItemClick;
			mp->Tag 	= -3;
			break;

		default:
			if (d <= get_dayn(CalYear, CalMon)) {
				//tݒ
				mp->Caption = UnicodeString().sprintf(_T(" %02u (%s)"),
								d, WeekStrJ[get_wek(CalYear, CalMon, d) - 1]);
				//c[`bv\ݒ
				//j
				_TCHAR tmp[31];
				CalHoliday->IsHoliday(CalYear, CalMon, d, tmp);
				UnicodeString hintstr = tmp;
				//
				if (ShowKoyomiTip) {
					UnicodeString k_str = Koyomi->GetInfoStr(CalYear, CalMon, d);
					UnicodeString k1str = get_tkn(k_str, "\t"); k_str = get_tkn_r(k_str, "\t");
					UnicodeString k2str = get_tkn(k_str, "\t");
					UnicodeString k3str = get_tkn_r(k_str, "\t");
					if (!k1str.IsEmpty()) {
						if (!hintstr.IsEmpty()) hintstr.UCAT_TSTR("\n ");
						hintstr += "" + k1str + " " +k2str;
					}
					if (!k3str.IsEmpty()) {
						if (!hintstr.IsEmpty()) hintstr.UCAT_TSTR("\n ");
						hintstr += k3str;
					}
				}
				//\
				if (ShowScheduleTip) {
					UnicodeString dtstr  = UnicodeString().sprintf(_T("%04u/%02u/%02u"), CalYear, CalMon, d);
					UnicodeString tmpstr = ScheduleList1->Values[dtstr];
					if (!tmpstr.IsEmpty()) {
						if (!hintstr.IsEmpty()) hintstr.UCAT_TSTR("\n ");
						hintstr += tmpstr;
					}
					tmpstr = ScheduleList2->Values[dtstr];
					if (!tmpstr.IsEmpty()) {
						if (!hintstr.IsEmpty()) hintstr.UCAT_TSTR("\n ");
						hintstr += tmpstr;
					}
				}
				mp->Hint = hintstr;
				mp->Tag  = d++;
			}
			else {
				mp->Caption = EmptyStr;
				mp->Hint	= EmptyStr;;
				mp->Tag 	= -1;
			}
		}
	}

	//\
	PopupMenu2->Popup(CalX, CalY);
}

//---------------------------------------------------------------------------
//Ǒ̃J_[\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalPrevMItemClick(TObject *Sender)
{
	CalMon--;
	if (CalMon==0) { CalMon = 12; CalYear--; }
	CalItemClick(Sender);
}
//---------------------------------------------------------------------------
//̌̃J_[\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalNextMItemClick(TObject *Sender)
{
	CalMon++;
	if (CalMon==13) { CalMon = 1; CalYear++; }
	CalItemClick(Sender);
}
//---------------------------------------------------------------------------
//O̔ÑJ_[\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalPrevYItemClick(TObject *Sender)
{
	CalYear--;
	CalItemClick(Sender);
}
//---------------------------------------------------------------------------
//̔ÑJ_[\
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalNextYItemClick(TObject *Sender)
{
	CalYear++;
	CalItemClick(Sender);
}

//---------------------------------------------------------------------------
//J_[̍ڕݒ
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalItemMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	//ݒ
	Width = ACanvas->TextWidth("@28 ()@29.53/ 199.99@") + 4;

	//ڂ̍𒲐
	Height += 2;	// (ƍL)
}
//---------------------------------------------------------------------------
//J_[̍ڂ`
//---------------------------------------------------------------------------
void __fastcall TMClockForm::CalItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, const TRect &ARect, bool Selected)
{
	TMenuItem *mp = (TMenuItem*)Sender;
	if (mp->Tag>0) {
		CaiItmHi = ARect.Height();
		ACanvas->Brush->Color = clBlack;
		ACanvas->FillRect(ARect);

		//̎擾
		unsigned short d = (unsigned short)mp->Tag;
		mooninf minf;
		minf.cur_dt = EncodeDate(CalYear, CalMon, d) + EncodeTime(CalMoonTime, 0, 0, 0);
		GetMoonInfo(&minf);

		//t
		if (CalYear==CurYear && CalMon==CurMon && d==CurDay)
			ACanvas->Font->Color = clLime;			//
		else {
			if (get_wek(CalYear, CalMon, d)==wixSUN)
				ACanvas->Font->Color  = clRed;		//j
			else if (CalHoliday->IsHoliday(CalYear, CalMon, d, NULL))
				ACanvas->Font->Color  = clRed;		//j
			else ACanvas->Font->Color = clWhite;	//
		}

		ACanvas->Brush->Color = clBlack;
		ACanvas->TextOut(ARect.Left + 6, ARect.Top + 2, mp->Caption);

		int x0, x1, x2, y0, y1;
		int w = ARect.Width()*3/5;
		x0 = ARect.Right - w - 4;
		x2 = ARect.Right - 4;
		y0 = ARect.Top + 4;
		y1 = ARect.Bottom - 4;
		//^Pʔ
		if (Selected) {
			UnicodeString tmp;
			tmp.sprintf(_T("%5.2f/ %6.2f%%%s"),
				 minf.age, minf.illuminated*100.0, (minf.phase<0.50)? _T("") : _T(""));
			ACanvas->Font->Color = clAqua;
			ACanvas->TextOut(x0, ARect.Top + 2, tmp);
		}
		//Pʔo[Ot
		else {
			TColor ic = (TColor)(
					((unsigned int)(0x0000c0*minf.illuminated) << 16) +				//B
					((unsigned int)(0x0000c0 + 0x00003f*minf.illuminated) << 8) +	//G
					 (unsigned int)(0x0000c0 + 0x00003f*minf.illuminated));			//R
			if (minf.phase<0.5) {
				x1 = x2-w*minf.illuminated;
				ACanvas->Brush->Color = clNavy;
				ACanvas->FillRect(Rect(x0, y0, x1, y1));
				ACanvas->Brush->Color = ic;
				ACanvas->FillRect(Rect(x1, y0, x2, y1));
			}
			else {
				x1 = x0+w*minf.illuminated;
				ACanvas->Brush->Color = ic;
				ACanvas->FillRect(Rect(x0, y0, x1, y1));
				ACanvas->Brush->Color = clNavy;
				ACanvas->FillRect(Rect(x1, y0, x2, y1));
			}
			ACanvas->Brush->Color = clBlue;
			ACanvas->FrameRect(Rect(x0, y0, x2, y1));
		}
	}
	else {
		if (mp->Tag==-1) {
			ACanvas->Brush->Color = clBlack;
			ACanvas->Font->Color  = clAqua;
		}
		else {
			ACanvas->Brush->Color = Selected ? clHighlight : clMenu;
		}
		int ymg = (mp->Tag==-2)? 4 : 2;
		ACanvas->FillRect(ARect);
		ACanvas->TextOut(ARect.Left + 6, ARect.Top + ymg, mp->Caption);
	}

	TRect rc = ARect;
	if (mp->Tag==-2) ::DrawEdge(ACanvas->Handle, &rc, EDGE_ETCHED, BF_TOP);
}

//---------------------------------------------------------------------------
//o[W`
//---------------------------------------------------------------------------
void __fastcall TMClockForm::VinfoItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, TRect &ARect, bool Selected)
{
	TMenuItem *tp =(TMenuItem*)Sender;
	ACanvas->Brush->Color = clBlack;
	ACanvas->FillRect(ARect);
	ACanvas->Font->Style = TFontStyles();

	switch (tp->Tag) {
	case 0:
		ACanvas->Draw(ARect.Left + 4, ARect.Bottom - 16, Application->Icon);
		ACanvas->Font->Style = ACanvas->Font->Style << fsBold;
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left + 44, ARect.Top + 2, "v");
		::DrawEdge(ACanvas->Handle, &ARect, BDR_SUNKENOUTER, BF_TOP|BF_LEFT|BF_RIGHT);
		break;
	case 1:
		ACanvas->Draw(ARect.Left + 4, ARect.Top - 16, Application->Icon);
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left + 48, ARect.Top + 2,
			"Version " + FloatToStrF(VersionNo/100.0, ffFixed, 4, 2));
		::DrawEdge(ACanvas->Handle, &ARect, BDR_SUNKENOUTER, BF_BOTTOM|BF_LEFT|BF_RIGHT);
		break;
	}
}

//---------------------------------------------------------------------------
//WebTCg
//---------------------------------------------------------------------------
void __fastcall TMClockForm::GoWebPageItemClick(TObject *Sender)
{
	::ShellExecute(NULL, _T("open"), SUPPORT_URL, NULL, NULL, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

