//----------------------------------------------------------------------//
// ^SNTPNCAg												//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <winsock.h>
#include "sntpcl.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
SntpClient *SNTPC = NULL;

//---------------------------------------------------------------------------
// NTPpPbg
struct NTP_packet
{
	int ctrl_word;
	int root_delay;
	int root_dispersion;
	int reference_id;
	__int64 reference_tstamp;
	__int64 originate_tstamp;
	__int64 receive_tstamp;
	int transmit_tstamp_sec;
	int transmit_tstamp_frac;
};

//---------------------------------------------------------------------------
SntpClient::SntpClient()
{
	ServerName = EmptyStr;
	TimeOut    = 5;
	AdjTime    = 0;
	OrgTime    = 0;
	ErrMsg	   = EmptyStr;
}

//---------------------------------------------------------------------------
SntpClient::~SntpClient()
{
}

//---------------------------------------------------------------------------
// T[o玞擾Ď킹
//  ߂l : Ȃ trueAs false  ErrMsg ݒ
//  OrgTime : CO̎
//  AdjTime : C
//---------------------------------------------------------------------------
bool SntpClient::TimeAdjust()
{
	SOCKET NTPsoc  = INVALID_SOCKET;
	ErrMsg	 = EmptyStr;
	bool ret = false;

	try {
		try {
			if (ServerName.IsEmpty()) throw EAbort("T[ow");

			//̗L
		    bool res = false;
		    HANDLE hToken;
			if (::OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken)) {
				TOKEN_PRIVILEGES tknPrvlgs;
				if (::LookupPrivilegeValue(NULL, SE_SYSTEMTIME_NAME, &(tknPrvlgs.Privileges[0].Luid))) {
					tknPrvlgs.PrivilegeCount = 1;
					tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
					::AdjustTokenPrivileges(hToken, FALSE, &tknPrvlgs, 0, NULL, NULL);
					res = (GetLastError()==ERROR_SUCCESS);
					if (!res) ErrMsg = SysErrorMessage(GetLastError());
			 	}
			    ::CloseHandle(hToken);
			}
		 	if (!res) {
				if (ErrMsg.IsEmpty()) ErrMsg = "̗LɎs";
		 		throw EAbort(ErrMsg);
			}

			//WinSock̏
			WSADATA wsaData;
			if (::WSAStartup(MAKEWORD(1, 1), &wsaData)!=0) throw EAbort("WinSock ̏s");

			//\Pbg쐬
			NTPsoc = socket(PF_INET, SOCK_DGRAM, 0);
			if (NTPsoc==INVALID_SOCKET) throw EAbort("\Pbg쐬s");

			//\Pbg̃AhX̍\̂ɃT[oIPAhXƃ|[gԍݒ
			SOCKADDR_IN soc_name;
			::ZeroMemory(&soc_name, sizeof(soc_name));
			soc_name.sin_family       = AF_INET;
			soc_name.sin_addr.s_addr  = INADDR_ANY;
			soc_name.sin_port         = htons(1024);
			if (bind(NTPsoc, (SOCKADDR*)&soc_name, sizeof(soc_name)) == SOCKET_ERROR)
				throw EAbort("M|[gԍ̎w莸s");

			unsigned long svr_ad = inet_addr(ServerName.c_str());
			if (svr_ad==INADDR_NONE) {
				//T[oT[ȍ擾
				struct hostent *svr_hostent = gethostbyname(ServerName.c_str());
				if (svr_hostent==NULL) throw EAbort("zXgAhX擾s");
				svr_ad = *((unsigned long *)((svr_hostent->h_addr_list)[0]));
			}

			// T[õAhX\̂IPAhXƃ|[gԍݒ
			SOCKADDR_IN  svr_soc_ad;
			::ZeroMemory(&svr_soc_ad, sizeof(svr_soc_ad));
			svr_soc_ad.sin_family       = AF_INET;
			svr_soc_ad.sin_addr.s_addr  = svr_ad;
			svr_soc_ad.sin_port         = htons(123);

			// NTPpPbgSNTPpɏ
			struct NTP_packet NTPsend;
			NTPsend.ctrl_word			 = htonl(0x0b000000);
			NTPsend.root_delay			 = 0;
			NTPsend.root_dispersion 	 = 0;
			NTPsend.reference_id		 = 0;
			NTPsend.reference_tstamp	 = 0;
			NTPsend.originate_tstamp	 = 0;
			NTPsend.receive_tstamp		 = 0;
			NTPsend.transmit_tstamp_sec  = 0;
			NTPsend.transmit_tstamp_frac = 0;

			// T[ow肵NTPpPbg𑗐M
			if (sendto(NTPsoc, (const char *)&NTPsend, sizeof(NTPsend), 
				0, (SOCKADDR*)&svr_soc_ad, sizeof(svr_soc_ad))==SOCKET_ERROR)
					throw EAbort("T[oւ̑Ms");

			TIMEVAL waittime;
			waittime.tv_sec  = TimeOut;
			waittime.tv_usec = 0;
			fd_set rdps;
			FD_ZERO(&rdps);
			FD_SET(NTPsoc, &rdps);

			int selret = select(FD_SETSIZE, &rdps, NULL, NULL, &waittime);
			if (selret == SOCKET_ERROR) throw EAbort("T[o̎Ms");
			if (selret == 0) throw EAbort("^CAEg");
			if (FD_ISSET(NTPsoc, &rdps)==FALSE) throw EAbort("T[o̎Ms");

			//T[ow肵ĎM
			struct NTP_packet NTP_Recv;
			int socad_sz = sizeof(svr_soc_ad);
			if (recvfrom(NTPsoc, (char *)&NTP_Recv, sizeof(NTP_Recv), 0, (SOCKADDR*)&svr_soc_ad, &socad_sz)
				== SOCKET_ERROR)
					throw EAbort("T[o̎Ms");

			//[J}V̎擾
			OrgTime = Now();

			//T[o擾[Jɕϊ
			time_t ntp_time = ntohl(NTP_Recv.transmit_tstamp_sec) - 2208988800;
			struct tm *lnewtime = localtime(&ntp_time);
			SYSTEMTIME	lsystime;
			lsystime.wYear   = lnewtime->tm_year + 1900;
			lsystime.wMonth  = lnewtime->tm_mon + 1;
			lsystime.wDay	 = lnewtime->tm_mday;
			lsystime.wHour   = lnewtime->tm_hour;
			lsystime.wMinute = lnewtime->tm_min;
			lsystime.wSecond = lnewtime->tm_sec;
			double ssec = (double)ntohl(NTP_Recv.transmit_tstamp_frac);
			ssec *= 0.00000000023283;
			ssec *= 1000.0;
			lsystime.wMilliseconds = (unsigned short)ssec;

			// [JT[o擾ɐݒ
			AdjTime = SystemTimeToDateTime(lsystime);
			ret = ::SetLocalTime(&lsystime);
			if (!ret) ErrMsg = SysErrorMessage(GetLastError());
		}
		catch(EAbort &e) {
			//G[̏
			ErrMsg = e.Message;
		}
	}
 	__finally {
		if (NTPsoc!=INVALID_SOCKET) closesocket(NTPsoc);
		::WSACleanup();
	}
	return ret;
}
//---------------------------------------------------------------------------
